%define dracutlibdir %{_prefix}/lib/dracut

# Variables must be defined
%define with_nbd                1

# nbd in Fedora only
%if 0%{?rhel} >= 6
%define with_nbd 0
%endif

Name: dracut
Version: 023
Release: 94.git20121009%{?dist}

Summary: Initramfs generator using udev
%if 0%{?fedora} || 0%{?rhel}
Group: System Environment/Base
%endif
%if 0%{?suse_version}
Group: System/Base
%endif

# The entire source code is GPLv2+
# except install/* which is LGPLv2.1+
License: GPLv2+ and LGPLv2.1+

URL: https://dracut.wiki.kernel.org/

# Source can be generated by
# http://git.kernel.org/?p=boot/dracut/dracut.git;a=snapshot;h=%{version};sf=tgz
Source0: http://www.kernel.org/pub/linux/utils/boot/dracut/dracut-%{version}.tar.bz2
Patch1: 0001-COPYING-updated-to-recent-version-of-http-www.gnu.or.patch
Patch2: 0002-dracut.conf.d-gentoo.conf.example-fix-header.patch
Patch3: 0003-dracut.conf.5.asc-s-dracut-conf.d-dracut.conf.d-g.patch
Patch4: 0004-include-the-omap_hsmmc-module-on-arm.patch
Patch5: 0005-mdraid-always-create-need_shutdown-if-we-have-assemb.patch
Patch6: 0006-add-back-scsi_wait_scan.patch
Patch7: 0007-network-reintroduce-rd.neednet.patch
Patch8: 0008-fips-set-boot-as-symlink-to-sysroot-boot-if-no-boot-.patch
Patch9: 0009-install-dracut-install.c-Ensure-deps-are-resolved-wh.patch
Patch10: 0010-install-dracut-install.c-Deal-gracefully-with-paths-.patch
Patch11: 0011-install-dracut-install.c-No-need-to-compare-the-NULL.patch
Patch12: 0012-udev-rules-Pre-usrmove-systemd-installs-might-not-fi.patch
Patch13: 0013-mdraid-catch-nested-md-raids.patch
Patch14: 0014-znet-add-some-more-kernel-drivers.patch
Patch15: 0015-network-add-ping-and-ping6.patch
Patch16: 0016-wait-host-devs-in-base-module.patch
Patch17: 0017-Add-for_each_host_dev_and_slaves-for-device-only-che.patch
Patch18: 0018-Add-a-dracut-option-device-to-bring-up-a-device-in-i.patch
Patch19: 0019-moved-the-etc-host_devs-write-out-to-99base.patch
Patch20: 0020-install-dracut-install.c-correct-usage-for-hmac.patch
Patch21: 0021-dracut-install-FIPS-workaround-for-fipscheck-dir.patch
Patch22: 0022-Require-fipscheck-and-libssl-in-FIPS-module.patch
Patch23: 0023-make-splitsep-preserve-backslashes-RHBZ-851295.patch
Patch24: 0024-crypt-do-not-run-systemd-crypt-generator.patch
Patch25: 0025-FIPS-workaround-for-fipscheck-dir.patch
Patch26: 0026-use-check_block_and_slaves-in-for_each_host_dev_and_.patch
Patch27: 0027-dracut-Override-rd.md-settings-if-rd.md.uuid-is-prov.patch
Patch28: 0028-dmsquash-live-dmsquash-live-root.sh-Physically-write.patch
Patch29: 0029-unquote-nbd-port.patch
Patch30: 0030-ifcfg-write-ifcfg.sh-add-IPV6INIT-yes-for-IPv6.patch
Patch31: 0031-kernel-modules-module-setup.sh-add-yenta_socket-to-t.patch
Patch32: 0032-network-fix-ip-ibft-regression.patch
Patch33: 0033-hide-setsid-help-output-in-emergency_shell.patch
Patch34: 0034-mdraid-parse-md.sh-fixed-commit-cc4037d12012244b51a1.patch
Patch35: 0035-apply-live-updates.sh-handle-updates-for-run.patch
Patch36: 0036-iscsi-parse-iscsiroot.sh-delay-loading-of-iscsi-modu.patch
Patch37: 0037-nfs-install-all-nfs-submodules.patch
Patch38: 0038-move-get_persistent_dev-to-dracut-functions.sh.patch
Patch39: 0039-resume-resume.sh-prevent-resume-not-found.patch
Patch40: 0040-bye-bye-iscsi_wait_scan-.-officially-gone-for-kernel.patch
Patch41: 0041-45url-lib-url-lib.sh-give-info-what-URL-curl-failed-.patch
Patch42: 0042-ismounted-fix.patch
Patch43: 0043-dash-compat-use-2-1-rather-than.patch
Patch44: 0044-fallback-to-old-ismounted-if-findmnt-is-not-installe.patch
Patch45: 0045-dracut-logger.sh-don-t-check-for-lvl-0-in-dlog_init.patch
Patch46: 0046-use-by-uuid-firstly-in-get_persistent_dev.patch
Patch47: 0047-systemd-initrd-switch-root.target-run-switch-root.ta.patch
Patch48: 0048-crypt-install-etc-crypttab-only-in-host-only-mode.patch
Patch49: 0049-udev-rules-module-setup.sh-add-udev-groups.patch
Patch50: 0050-TEST-03-USR-MOUNT-create-root.sh-load-btrfs-module-m.patch
Patch51: 0051-TEST-10-RAID-test.sh-add-rd.auto-1.patch
Patch52: 0052-i18n-10-console.rules-do-the-console-init-only-one-t.patch
Patch53: 0053-url-lib-module-setup.sh-also-install-libs-for-https.patch
Patch54: 0054-busybox-fix-installation-from-sbin-busybox.patch
Patch55: 0055-busybox-module-setup.sh-generate-nice-relative-symli.patch
Patch56: 0056-install-dracut-install.c-support-find_binary-for-src.patch
Patch57: 0057-dracut.cmdline.7.asc-fixed-rd.luks.allow-discards-fo.patch
Patch58: 0058-crypt-crypt-run-generator.sh-add-allow-discards-to-o.patch
Patch59: 0059-TEST-16-DMSQUASH-reenable-test.patch
Patch60: 0060-dm-module-setup.sh-instmods-dm_mod.patch
Patch61: 0061-dracut.sh-create-the-initramfs-non-world-readable.patch
Patch62: 0062-network-ifup.sh-setup-nameserver-for-every-interface.patch
Patch63: 0063-shutdown-shutdown.sh-reboot-if-no-argument-was-given.patch
Patch64: 0064-TODO-update.patch
Patch65: 0065-Support-GNOME-Build-API.patch
Patch66: 0066-add-rd.auto-parameter-and-switch-off-automatic-assem.patch
Patch67: 0067-build-Add-disable-documentation-option.patch
Patch68: 0068-Makefile-revert-documentation-logic.patch
Patch69: 0069-dracut-functions.sh-get_persistent_dev-exception-for.patch
Patch70: 0070-dracut.cmdline.7.asc-extend-rd.auto-doc.patch
Patch71: 0071-Makefile-fix-css-style-for-dracut.html.patch
Patch72: 0072-i18n-parse-i18n.sh-corrected-the-right-option-to-use.patch
Patch73: 0073-base-dracut-lib.sh-better-error-message-for-deprecat.patch
Patch74: 0074-dracut-functions.sh-make-hostonly-case-more-failsafe.patch
Patch75: 0075-dracut-functions.sh-do-not-check-all-modules-for-fil.patch
Patch76: 0076-systemd-module-setup.sh-move-some-services-to-sysini.patch
Patch77: 0077-install-dracut-install.c-do-not-ldd-directories.patch
Patch78: 0078-systemd-improve-the-emergency-shell.patch
Patch79: 0079-dracut-functions.sh-move-the-i2o_scsi-to-the-omit_dr.patch
Patch80: 0080-dracut-functions.sh-inst_rules_program-also-recogniz.patch
Patch81: 0081-dracut-functions-add-inst_rule_group_owner.patch
Patch82: 0082-add-kernel-cmdline-and-kernel_cmdline-options-for-de.patch
Patch83: 0083-systemd-rename-emergency.service-to-dracut-emergency.patch
Patch84: 0084-s-libnss-.so-libnss_-.so-so-that-we-don-t-install-li.patch
Patch85: 0085-90crypt-call-systemd-commands-only-if-systemd-binari.patch
Patch86: 0086-dracut-functions.sh-find_binary-path-starting-with-v.patch
Patch87: 0087-return-proper-value-in-function-dracut_install.patch
Patch88: 0088-TEST-50-MULTINIC-test.sh-fix-multinic-issues.patch
Patch89: 0089-TEST-20-NFS-test.sh-reformat.patch
Patch90: 0090-shutdown-shutdown.sh-failsafe-shutdown-for-kexec.patch
Patch91: 0091-i18n-parse-i18n.sh-correctly-populate-etc-vconsole.c.patch
Patch92: 0092-dracut-functions.sh-inst_rules_program-skip-udev-var.patch
Patch93: 0093-test-disable-systemd-for-encryption.patch


BuildRequires: dash bash git

%if 0%{?fedora} || 0%{?rhel}
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
%endif
%if 0%{?suse_version}
BuildRoot: %{_tmppath}/%{name}-%{version}-build
%endif

%if 0%{?fedora} || 0%{?rhel}
BuildRequires: docbook-style-xsl docbook-dtds libxslt
%endif

%if 0%{?suse_version}
-BuildRequires: docbook-xsl-stylesheets libxslt
%endif

BuildRequires: asciidoc

%if 0%{?fedora} > 12 || 0%{?rhel}
# no "provides", because dracut does not offer
# all functionality of the obsoleted packages
Obsoletes: mkinitrd <= 6.0.93
Obsoletes: mkinitrd-devel <= 6.0.93
Obsoletes: nash <= 6.0.93
Obsoletes: libbdevid-python <= 6.0.93
%endif

%if 0%{?fedora} > 16 || 0%{?rhel} > 6
BuildRequires: systemd-units
%endif

%if 0%{?suse_version} > 9999
Obsoletes: mkinitrd < 2.6.1
Provides: mkinitrd = 2.6.1
%endif

Obsoletes: dracut-kernel < 005
Provides:  dracut-kernel = %{version}-%{release}

Requires: bash
Requires: coreutils
Requires: cpio
Requires: filesystem >= 2.1.0
Requires: findutils
Requires: grep
Requires: hardlink
Requires: gzip xz
Requires: module-init-tools >= 3.7-9
Requires: sed
Requires: file
Requires: kpartx
Requires: udev > 166
Requires: kbd kbd-misc
%if 0%{?fedora} || 0%{?rhel} > 6
Requires: util-linux >= 2.21
Conflicts: systemd < 187
%else
Requires: util-linux-ng >= 2.21
%endif

%if 0%{?fedora} || 0%{?rhel} > 6
Conflicts: initscripts < 8.63-1
Conflicts: plymouth < 0.8.0-0.2009.29.09.19.1
%endif

%description
Dracut contains tools to create a bootable initramfs for 2.6 Linux kernels.
Unlike existing implementations, dracut does hard-code as little as possible
into the initramfs. Dracut contains various modules which are driven by the
event-based udev. Having root on MD, DM, LVM2, LUKS is supported as well as
NFS, iSCSI, NBD, FCoE with the dracut-network package.

%package network
Summary: Dracut modules to build a dracut initramfs with network support
Requires: %{name} = %{version}-%{release}
Obsoletes: dracut-generic < 008
Provides:  dracut-generic = %{version}-%{release}

%description network
This package requires everything which is needed to build a generic
all purpose initramfs with network support with dracut.

%if 0%{?fedora} || 0%{?rhel} >= 6 || 0%{?suse_version}
%package fips
Summary: Dracut modules to build a dracut initramfs with an integrity check
Requires: %{name} = %{version}-%{release}
Requires: hmaccalc
%if 0%{?rhel} > 5
# For Alpha 3, we want nss instead of nss-softokn
Requires: nss
%else
Requires: nss-softokn
%endif
Requires: nss-softokn-freebl

%description fips
This package requires everything which is needed to build an
all purpose initramfs with dracut, which does an integrity check.
%endif

%package fips-aesni
Summary: Dracut modules to build a dracut initramfs with an integrity check with aesni-intel
Requires: %{name}-fips = %{version}-%{release}

%description fips-aesni
This package requires everything which is needed to build an
all purpose initramfs with dracut, which does an integrity check
and adds the aesni-intel kernel module.

%package caps
Summary: Dracut modules to build a dracut initramfs which drops capabilities
Requires: %{name} = %{version}-%{release}
Requires: libcap

%description caps
This package requires everything which is needed to build an
all purpose initramfs with dracut, which drops capabilities.

%package tools
Summary: Dracut tools to build the local initramfs
Requires: %{name} = %{version}-%{release}

%description tools
This package contains tools to assemble the local initrd and host configuration.

%prep
%setup -q -n %{name}-%{version}

%if %{defined PATCH1}
git init
git config user.email "dracut-maint@redhat.com"
git config user.name "Fedora dracut team"
git add .
git commit -a -q -m "%{version} baseline."

# Apply all the patches.
git am -p1 %{patches}
%endif

%build
make all

%install
%if 0%{?fedora} || 0%{?rhel}
rm -rf $RPM_BUILD_ROOT
%endif
make install DESTDIR=$RPM_BUILD_ROOT \
     libdir=%{_prefix}/lib \
     bindir=%{_bindir} \
%if %{defined _unitdir}
     systemdsystemunitdir=%{_unitdir} \
%endif
     sysconfdir=/etc mandir=%{_mandir}

echo "DRACUT_VERSION=%{version}-%{release}" > $RPM_BUILD_ROOT/%{dracutlibdir}/dracut-version.sh

%if 0%{?fedora} == 0 && 0%{?rhel} == 0 && 0%{?suse_version} == 0
rm -fr $RPM_BUILD_ROOT/%{dracutlibdir}/modules.d/01fips
rm -fr $RPM_BUILD_ROOT/%{dracutlibdir}/modules.d/02fips-aesni
%endif

# we do not support dash in the initramfs
rm -fr $RPM_BUILD_ROOT/%{dracutlibdir}/modules.d/00dash

# remove gentoo specific modules
rm -fr $RPM_BUILD_ROOT/%{dracutlibdir}/modules.d/50gensplash

%if %{defined _unitdir}
# with systemd IMA and selinux modules do not make sense
rm -fr $RPM_BUILD_ROOT/%{dracutlibdir}/modules.d/96securityfs
rm -fr $RPM_BUILD_ROOT/%{dracutlibdir}/modules.d/97masterkey
rm -fr $RPM_BUILD_ROOT/%{dracutlibdir}/modules.d/98integrity
rm -fr $RPM_BUILD_ROOT/%{dracutlibdir}/modules.d/98selinux
%endif

mkdir -p $RPM_BUILD_ROOT/boot/dracut
mkdir -p $RPM_BUILD_ROOT/var/lib/dracut/overlay
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/log
touch $RPM_BUILD_ROOT%{_localstatedir}/log/dracut.log
mkdir -p $RPM_BUILD_ROOT%{_sharedstatedir}/initramfs

%if 0%{?fedora} || 0%{?rhel} || 0%{?suse_version}
install -m 0644 dracut.conf.d/fedora.conf.example $RPM_BUILD_ROOT/etc/dracut.conf.d/01-dist.conf
install -m 0644 dracut.conf.d/fips.conf.example $RPM_BUILD_ROOT/etc/dracut.conf.d/40-fips.conf
%endif

%if 0%{?suse_version}
install -m 0644 dracut.conf.d/suse.conf.example   $RPM_BUILD_ROOT/etc/dracut.conf.d/01-dist.conf
%endif

%if 0%{?fedora} <= 12 && 0%{?rhel} < 6 && 0%{?suse_version} <= 9999
rm $RPM_BUILD_ROOT%{_bindir}/mkinitrd
rm $RPM_BUILD_ROOT%{_bindir}/lsinitrd
%endif

mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
install -m 0644 dracut.logrotate $RPM_BUILD_ROOT/etc/logrotate.d/dracut_log

# create compat symlink
mkdir -p $RPM_BUILD_ROOT/sbin
ln -s /usr/bin/dracut $RPM_BUILD_ROOT/sbin/dracut

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,0755)
%doc README HACKING TODO COPYING AUTHORS NEWS dracut.html dracut.png dracut.svg
%{_bindir}/dracut
# compat symlink
/sbin/dracut
%if 0%{?fedora} > 12 || 0%{?rhel} >= 6 || 0%{?suse_version} > 9999
%{_bindir}/mkinitrd
%{_bindir}/lsinitrd
%endif
%dir %{dracutlibdir}
%dir %{dracutlibdir}/modules.d
%{dracutlibdir}/dracut-functions.sh
%{dracutlibdir}/dracut-functions
%{dracutlibdir}/dracut-version.sh
%{dracutlibdir}/dracut-logger.sh
%{dracutlibdir}/dracut-initramfs-restore
%{dracutlibdir}/dracut-install
%config(noreplace) /etc/dracut.conf
%if 0%{?fedora} || 0%{?suse_version} || 0%{?rhel}
%config /etc/dracut.conf.d/01-dist.conf
%endif
%dir /etc/dracut.conf.d
%{_mandir}/man8/dracut.8*
%{_mandir}/man8/*service.8*
%if 0%{?fedora} > 12 || 0%{?rhel} >= 6 || 0%{?suse_version} > 9999
%{_mandir}/man8/mkinitrd.8*
%{_mandir}/man1/lsinitrd.1*
%endif
%{_mandir}/man7/dracut.kernel.7*
%{_mandir}/man7/dracut.cmdline.7*
%{_mandir}/man5/dracut.conf.5*
%{dracutlibdir}/modules.d/00bootchart
%{dracutlibdir}/modules.d/04watchdog
%{dracutlibdir}/modules.d/05busybox
%{dracutlibdir}/modules.d/10i18n
%{dracutlibdir}/modules.d/30convertfs
%{dracutlibdir}/modules.d/45url-lib
%{dracutlibdir}/modules.d/50plymouth
%{dracutlibdir}/modules.d/80cms
%{dracutlibdir}/modules.d/90btrfs
%{dracutlibdir}/modules.d/90crypt
%{dracutlibdir}/modules.d/90dm
%{dracutlibdir}/modules.d/90dmraid
%{dracutlibdir}/modules.d/90dmsquash-live
%{dracutlibdir}/modules.d/90kernel-modules
%{dracutlibdir}/modules.d/90lvm
%{dracutlibdir}/modules.d/90mdraid
%{dracutlibdir}/modules.d/90multipath
%{dracutlibdir}/modules.d/90qemu
%{dracutlibdir}/modules.d/91crypt-gpg
%{dracutlibdir}/modules.d/91crypt-loop
%{dracutlibdir}/modules.d/95debug
%{dracutlibdir}/modules.d/95resume
%{dracutlibdir}/modules.d/95rootfs-block
%{dracutlibdir}/modules.d/95dasd
%{dracutlibdir}/modules.d/95dasd_mod
%{dracutlibdir}/modules.d/95fstab-sys
%{dracutlibdir}/modules.d/95zfcp
%{dracutlibdir}/modules.d/95terminfo
%{dracutlibdir}/modules.d/95udev-rules
%{dracutlibdir}/modules.d/95virtfs
%if %{undefined _unitdir}
%{dracutlibdir}/modules.d/96securityfs
%{dracutlibdir}/modules.d/97masterkey
%{dracutlibdir}/modules.d/98selinux
%{dracutlibdir}/modules.d/98integrity
%endif
%{dracutlibdir}/modules.d/97biosdevname
%{dracutlibdir}/modules.d/98ecryptfs
%{dracutlibdir}/modules.d/98pollcdrom
%{dracutlibdir}/modules.d/98syslog
%{dracutlibdir}/modules.d/98systemd
%{dracutlibdir}/modules.d/98usrmount
%{dracutlibdir}/modules.d/99base
%{dracutlibdir}/modules.d/99fs-lib
%{dracutlibdir}/modules.d/99img-lib
%{dracutlibdir}/modules.d/99shutdown
%config(noreplace) /etc/logrotate.d/dracut_log
%attr(0644,root,root) %ghost %config(missingok,noreplace) %{_localstatedir}/log/dracut.log
%dir %{_sharedstatedir}/initramfs
%if %{defined _unitdir}
%{_unitdir}/dracut-shutdown.service
%{_unitdir}/shutdown.target.wants/dracut-shutdown.service
%endif

%files network
%defattr(-,root,root,0755)
%{dracutlibdir}/modules.d/40network
%{dracutlibdir}/modules.d/95fcoe
%{dracutlibdir}/modules.d/95iscsi
%{dracutlibdir}/modules.d/90livenet
%{dracutlibdir}/modules.d/90qemu-net
%{dracutlibdir}/modules.d/95cifs
%{dracutlibdir}/modules.d/95nbd
%{dracutlibdir}/modules.d/95nfs
%{dracutlibdir}/modules.d/95ssh-client
%{dracutlibdir}/modules.d/45ifcfg
%{dracutlibdir}/modules.d/95znet

%if 0%{?fedora} || 0%{?rhel} || 0%{?suse_version}
%files fips
%defattr(-,root,root,0755)
%{dracutlibdir}/modules.d/01fips
%config(noreplace) /etc/dracut.conf.d/40-fips.conf
%endif

%files fips-aesni
%defattr(-,root,root,0755)
%doc COPYING
%{dracutlibdir}/modules.d/02fips-aesni

%files caps
%defattr(-,root,root,0755)
%{dracutlibdir}/modules.d/02caps

%files tools
%defattr(-,root,root,0755)
%{_mandir}/man8/dracut-catimages.8*
%{_bindir}/dracut-catimages
%dir /boot/dracut
%dir /var/lib/dracut
%dir /var/lib/dracut/overlay

%changelog
